﻿using Hotline.Snapshot;
using Hotline.Snapshot.Interfaces;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using XF.Domain.Repository.Events;

namespace Hotline.Orders.DatabaseEventHandler;
public class OrderSnapshotEventHandler : IUpdateDatabaseEvent<OrderSnapshot>
{
    private readonly IIndustryLogRepository _industryLogRepository;

    public OrderSnapshotEventHandler(IIndustryLogRepository industryLogRepository)
    {
        _industryLogRepository = industryLogRepository;
    }

    public void OnInserted(OrderSnapshot entity)
    {
    }

    public void OnUpdated(OrderSnapshot entity)
    {
    }

    public void OnUpdating(object oldValue, string propertyName, OrderSnapshot entity)
    {
        if (oldValue == null) return;
        if (propertyName != "IndustryName") return;
        if (oldValue is String industryName)
        {
            if (industryName == entity.IndustryName) return;
            var entityLog = new IndustryLog
            {
                IndustryName = oldValue.ToString(),
                OldIndustryName = industryName,
                CreationTime = DateTime.Now,
                OrderId = entity.Id,
            };
            _industryLogRepository.AddAsync(entityLog).GetAwaiter().GetResult();
        }
    }
}
